// stek2.h - Deklaracije paketa za stekove neograničenih kapaciteta.

typedef struct elem { int broj; struct elem *sled; } Elem;
typedef Elem *Stek;

Stek stvori(void);                           // Stvaranje praznog steka.
void stavi(Stek *stk, int b);                // Stavljanje broja na stek.
int uzmi(Stek *stk);                         // Uzimanje broja sa steka.
_Bool prazan(Stek stk);                      // Da li je stek prazan?
void pisi(Stek stk);                         // Ispisivanje sadržaja steka.
void prazni(Stek *stk);                      // Pražnjenje steka.
void unisti(Stek *stk);                      // Uništavanje steka.
